/**
 */
package books;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Genre</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see books.BooksPackage#getGenre()
 * @model
 * @generated
 */
public enum Genre implements Enumerator {
	/**
	 * The '<em><b>Fantasy</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FANTASY_VALUE
	 * @generated
	 * @ordered
	 */
	FANTASY(0, "Fantasy", "Fantasy"),

	/**
	 * The '<em><b>Textbook</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TEXTBOOK_VALUE
	 * @generated
	 * @ordered
	 */
	TEXTBOOK(1, "Textbook", "Textbook"),

	/**
	 * The '<em><b>Horror</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #HORROR_VALUE
	 * @generated
	 * @ordered
	 */
	HORROR(2, "Horror", "Horror");

	/**
	 * The '<em><b>Fantasy</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Fantasy</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FANTASY
	 * @model name="Fantasy"
	 * @generated
	 * @ordered
	 */
	public static final int FANTASY_VALUE = 0;

	/**
	 * The '<em><b>Textbook</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Textbook</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TEXTBOOK
	 * @model name="Textbook"
	 * @generated
	 * @ordered
	 */
	public static final int TEXTBOOK_VALUE = 1;

	/**
	 * The '<em><b>Horror</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Horror</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #HORROR
	 * @model name="Horror"
	 * @generated
	 * @ordered
	 */
	public static final int HORROR_VALUE = 2;

	/**
	 * An array of all the '<em><b>Genre</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final Genre[] VALUES_ARRAY =
		new Genre[] {
			FANTASY,
			TEXTBOOK,
			HORROR,
		};

	/**
	 * A public read-only list of all the '<em><b>Genre</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<Genre> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Genre</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static Genre get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			Genre result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Genre</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static Genre getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			Genre result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Genre</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static Genre get(int value) {
		switch (value) {
			case FANTASY_VALUE: return FANTASY;
			case TEXTBOOK_VALUE: return TEXTBOOK;
			case HORROR_VALUE: return HORROR;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private Genre(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //Genre
