/**
 */
package books.impl;

import books.Author;
import books.Book;
import books.BookStore;
import books.BooksPackage;
import books.Edition;
import books.Genre;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Book</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link books.impl.BookImpl#getTitle <em>Title</em>}</li>
 *   <li>{@link books.impl.BookImpl#getGenre <em>Genre</em>}</li>
 *   <li>{@link books.impl.BookImpl#getStore <em>Store</em>}</li>
 *   <li>{@link books.impl.BookImpl#getEditions <em>Editions</em>}</li>
 *   <li>{@link books.impl.BookImpl#getAuthors <em>Authors</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BookImpl extends MinimalEObjectImpl.Container implements Book {
	/**
	 * The default value of the '{@link #getTitle() <em>Title</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTitle()
	 * @generated
	 * @ordered
	 */
	protected static final String TITLE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTitle() <em>Title</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTitle()
	 * @generated
	 * @ordered
	 */
	protected String title = TITLE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getGenre() <em>Genre</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGenre()
	 * @generated
	 * @ordered
	 */
	protected EList<Genre> genre;

	/**
	 * The cached value of the '{@link #getEditions() <em>Editions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEditions()
	 * @generated
	 * @ordered
	 */
	protected EList<Edition> editions;

	/**
	 * The cached value of the '{@link #getAuthors() <em>Authors</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAuthors()
	 * @generated
	 * @ordered
	 */
	protected EList<Author> authors;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BookImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return BooksPackage.Literals.BOOK;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getTitle() {
		return title;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTitle(String newTitle) {
		String oldTitle = title;
		title = newTitle;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BooksPackage.BOOK__TITLE, oldTitle, title));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Genre> getGenre() {
		if (genre == null) {
			genre = new EDataTypeUniqueEList<Genre>(Genre.class, this, BooksPackage.BOOK__GENRE);
		}
		return genre;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BookStore getStore() {
		if (eContainerFeatureID() != BooksPackage.BOOK__STORE) return null;
		return (BookStore)eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStore(BookStore newStore, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newStore, BooksPackage.BOOK__STORE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStore(BookStore newStore) {
		if (newStore != eInternalContainer() || (eContainerFeatureID() != BooksPackage.BOOK__STORE && newStore != null)) {
			if (EcoreUtil.isAncestor(this, newStore))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStore != null)
				msgs = ((InternalEObject)newStore).eInverseAdd(this, BooksPackage.BOOK_STORE__BOOKS, BookStore.class, msgs);
			msgs = basicSetStore(newStore, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, BooksPackage.BOOK__STORE, newStore, newStore));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Edition> getEditions() {
		if (editions == null) {
			editions = new EObjectContainmentWithInverseEList<Edition>(Edition.class, this, BooksPackage.BOOK__EDITIONS, BooksPackage.EDITION__BOOK);
		}
		return editions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Author> getAuthors() {
		if (authors == null) {
			authors = new EObjectWithInverseResolvingEList.ManyInverse<Author>(Author.class, this, BooksPackage.BOOK__AUTHORS, BooksPackage.AUTHOR__BOOKS);
		}
		return authors;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case BooksPackage.BOOK__STORE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetStore((BookStore)otherEnd, msgs);
			case BooksPackage.BOOK__EDITIONS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getEditions()).basicAdd(otherEnd, msgs);
			case BooksPackage.BOOK__AUTHORS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getAuthors()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case BooksPackage.BOOK__STORE:
				return basicSetStore(null, msgs);
			case BooksPackage.BOOK__EDITIONS:
				return ((InternalEList<?>)getEditions()).basicRemove(otherEnd, msgs);
			case BooksPackage.BOOK__AUTHORS:
				return ((InternalEList<?>)getAuthors()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case BooksPackage.BOOK__STORE:
				return eInternalContainer().eInverseRemove(this, BooksPackage.BOOK_STORE__BOOKS, BookStore.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case BooksPackage.BOOK__TITLE:
				return getTitle();
			case BooksPackage.BOOK__GENRE:
				return getGenre();
			case BooksPackage.BOOK__STORE:
				return getStore();
			case BooksPackage.BOOK__EDITIONS:
				return getEditions();
			case BooksPackage.BOOK__AUTHORS:
				return getAuthors();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case BooksPackage.BOOK__TITLE:
				setTitle((String)newValue);
				return;
			case BooksPackage.BOOK__GENRE:
				getGenre().clear();
				getGenre().addAll((Collection<? extends Genre>)newValue);
				return;
			case BooksPackage.BOOK__STORE:
				setStore((BookStore)newValue);
				return;
			case BooksPackage.BOOK__EDITIONS:
				getEditions().clear();
				getEditions().addAll((Collection<? extends Edition>)newValue);
				return;
			case BooksPackage.BOOK__AUTHORS:
				getAuthors().clear();
				getAuthors().addAll((Collection<? extends Author>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case BooksPackage.BOOK__TITLE:
				setTitle(TITLE_EDEFAULT);
				return;
			case BooksPackage.BOOK__GENRE:
				getGenre().clear();
				return;
			case BooksPackage.BOOK__STORE:
				setStore((BookStore)null);
				return;
			case BooksPackage.BOOK__EDITIONS:
				getEditions().clear();
				return;
			case BooksPackage.BOOK__AUTHORS:
				getAuthors().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case BooksPackage.BOOK__TITLE:
				return TITLE_EDEFAULT == null ? title != null : !TITLE_EDEFAULT.equals(title);
			case BooksPackage.BOOK__GENRE:
				return genre != null && !genre.isEmpty();
			case BooksPackage.BOOK__STORE:
				return getStore() != null;
			case BooksPackage.BOOK__EDITIONS:
				return editions != null && !editions.isEmpty();
			case BooksPackage.BOOK__AUTHORS:
				return authors != null && !authors.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (title: ");
		result.append(title);
		result.append(", genre: ");
		result.append(genre);
		result.append(')');
		return result.toString();
	}

} //BookImpl
